"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = tslib_1.__importStar(require("react"));
var resize_observer_polyfill_1 = tslib_1.__importDefault(require("resize-observer-polyfill"));
var use_callback_ref_1 = require("./use-callback-ref");
function useMeasure(ref) {
    var _a = use_callback_ref_1.useCallbackRef(), element = _a[0], attachRef = _a[1];
    // unsure if this would be better defaulting to null. I think
    // in practice it's easier to just use default values of 0
    var _b = React.useState({
        left: 0,
        height: 0,
        top: 0,
        width: 0,
        bottom: 0,
        x: 0,
        y: 0,
        right: 0
    }), bounds = _b[0], setBounds = _b[1];
    // bind resize handler
    React.useEffect(function () {
        function onResize(_a) {
            var entry = _a[0];
            setBounds(entry.contentRect);
        }
        var observer = new resize_observer_polyfill_1.default(onResize);
        if (element && element.current) {
            observer.observe(element.current);
        }
        return function () {
            observer.disconnect();
        };
    }, [element]);
    // attach our ref
    React.useEffect(function () {
        attachRef(ref);
    }, []);
    return { bounds: bounds };
}
exports.useMeasure = useMeasure;
