"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var popper_js_1 = tslib_1.__importDefault(require("popper.js"));
var React = tslib_1.__importStar(require("react"));
var use_callback_ref_1 = require("./use-callback-ref");
var defaultStyle = {
    position: "absolute",
    top: 0,
    left: 0,
    opacity: 0,
    pointerEvents: "none"
};
/**
 * Position an element relative to another
 */
function usePositioner(_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.placement, defaultPlacement = _c === void 0 ? "bottom" : _c, _d = _b.positionFixed, positionFixed = _d === void 0 ? false : _d, _e = _b.eventsEnabled, eventsEnabled = _e === void 0 ? true : _e, _f = _b.modifiers, modifiers = _f === void 0 ? {} : _f;
    var _g = use_callback_ref_1.useCallbackRef(), target = _g[0], attachTarget = _g[1];
    var _h = use_callback_ref_1.useCallbackRef(), popover = _h[0], attachPopover = _h[1];
    var _j = use_callback_ref_1.useCallbackRef(), arrow = _j[0], attachArrow = _j[1];
    // positions
    var _k = React.useState(defaultStyle), popperStyle = _k[0], setPopperStyle = _k[1];
    var _l = React.useState({}), arrowStyle = _l[0], setArrowStyle = _l[1];
    var _m = React.useState(null), placement = _m[0], setPlacement = _m[1];
    React.useEffect(function () {
        if (!target || !popover) {
            return;
        }
        function updatePopperState(data) {
            var styles = data.styles, arrowStyles = data.arrowStyles, place = data.placement;
            setPopperStyle(styles);
            setArrowStyle(arrowStyles);
            setPlacement(place);
            return data;
        }
        //  @ts-ignore
        var pop = new popper_js_1.default(target, popover, {
            placement: defaultPlacement,
            positionFixed: positionFixed,
            eventsEnabled: eventsEnabled,
            modifiers: tslib_1.__assign({}, modifiers, { arrow: tslib_1.__assign({}, (modifiers && modifiers.arrow), { enabled: true, element: arrow }), applyStyle: { enabled: false }, updateStateModifier: {
                    enabled: true,
                    order: 900,
                    fn: updatePopperState
                } })
        });
        return function () {
            if (pop) {
                pop.destroy();
            }
        };
    }, [target, popover, defaultPlacement, eventsEnabled, positionFixed, arrow]);
    return {
        target: {
            ref: attachTarget,
            node: target
        },
        popover: {
            node: popover,
            style: popperStyle,
            ref: attachPopover,
            placement: placement
        },
        arrow: {
            node: arrow,
            style: arrowStyle,
            ref: attachArrow
        }
    };
}
exports.usePositioner = usePositioner;
