import * as tslib_1 from "tslib";
import * as React from "react";
import createFocusTrap from "focus-trap";
export function useFocusElement(elementRef, showing, options) {
    if (options === void 0) { options = {}; }
    React.useEffect(function () {
        var trap;
        function focusElement() {
            if (!elementRef.current) {
                console.error("No element found to found");
                return;
            }
            trap = createFocusTrap(elementRef.current, tslib_1.__assign({ escapeDeactivates: false, clickOutsideDeactivates: true, fallbackFocus: '[tabindex="-1"]' }, options));
            trap.activate();
        }
        function focusTrigger() {
            if (!trap) {
                return;
            }
            trap.deactivate();
        }
        if (showing) {
            focusElement();
            return function () {
                focusTrigger();
            };
        }
    }, [showing]);
}
